'FFName= Namensbestandteil
'** Filterung der Computeransicht nach Teilstring
'** Andreas Kleingnther, 
' Version 2.1 vom 08.05.2011
' Version 2.2 vom 31.10.2012	Dateiendung wird mit durchsucht, Case sensitive
' Version 2.3 vom 03.11.2012	Aufruflogik verndert, beim Verzeichniswechsel bleibt "nicht filtern" erhalten
' Version 2.4 vom 29.12.2012	Bercksichtigung der Dateiendung optional
' Version 2.5 vom 23.03.2014	Fehlerbehebung Differenzfilter (Dateiendung optional
' Version 2.6 vom 29.07.2016	erneut Fehlerbehebung Differenzfilter (bei Bercksichtigung der Dateiendung)

Option Explicit
const Version = "V 2.6"
const RegSchluessel = "Namensfilter"						'Registryschlssel
Dim fso
Set fso = CreateObject("Scripting.FileSystemObject")

Dim str, files, pfad, wort, i, opt_stringnot, opt_merken, eingabe, Taste
Dim opt_zeichenkette, opt_differenz, opt_nichtfiltern
Dim letztes_Verzeichnis, akt_pfad, mark 
Dim u, Filemerker, Name, Name1, Fundstelle
Dim opt_casesense, opt_endung

Call Main

Sub Main
	if FF_GetProfile (RegSchluessel,"Initialisierung") <> "1" then
		Call Initalisierung_Registry
		mark = 1
	end if

	letztes_Verzeichnis = FF_GetProfile(RegSchluessel,"akt_Computeransicht")
	akt_pfad = FF_GetImagePath
	REM msgbox letztes_Verzeichnis 
	REM MsgBox akt_pfad

	if letztes_Verzeichnis <> akt_pfad and mark = 0 then		' Pfad wurde gendert
		REM msgbox "Pfad wurde gendert, kein Dialog"
		wort = FF_GetProfile(RegSchluessel,"eingabe")
		opt_stringnot = FF_GetProfile(RegSchluessel,"opt_stringnot")
		opt_merken = FF_GetProfile(RegSchluessel,"opt_merken")
		opt_zeichenkette = FF_GetProfile(RegSchluessel,"opt_zeichenkette")
		opt_differenz = FF_GetProfile(RegSchluessel,"opt_differenz")
		opt_casesense = FF_GetProfile(RegSchluessel,"casesense_bool")
		opt_nichtfiltern = FF_GetProfile(RegSchluessel,"opt_nichtfiltern")
		opt_endung = FF_GetProfile(RegSchluessel,"opt_endung")
	else
		Call Dialogaufbau
		
		opt_merken = FF_GetProfile(RegSchluessel,"opt_merken")
		
		if opt_merken = "1" then								' Eingaben merken ist aktiv
			'msgbox "merken gesetzt"
			FF_SetControl "Filter Namensbestandteil","eingabe1", FF_GetProfile(RegSchluessel,"eingabe")
			FF_SetControl "Filter Namensbestandteil","string_bool", FF_GetProfile(RegSchluessel,"opt_zeichenkette")
			FF_SetControl "Filter Namensbestandteil","diff_bool", FF_GetProfile(RegSchluessel,"opt_differenz")
			FF_SetControl "Filter Namensbestandteil","bool1", FF_GetProfile(RegSchluessel,"opt_stringnot")
			FF_SetControl "Filter Namensbestandteil","bool2", FF_GetProfile(RegSchluessel,"opt_merken")
			FF_SetControl "Filter Namensbestandteil","casesen_bool", FF_GetProfile(RegSchluessel,"opt_casesense")
			FF_SetControl "Filter Namensbestandteil","endung_bool", FF_GetProfile(RegSchluessel,"opt_endung")
		Else
			FF_SetControl "Filter Namensbestandteil","string_bool", "1"						' Startzustand wieder herstellen
		end if		
		
		FF_ActivateControl"Filter Namensbestandteil","eingabe1"	' Fokus auf Eingabefeld
		do														' Auswertung Button
			Taste = FF_ShowDialog("Filter Namensbestandteil")
			Select Case Taste
				Case "string_bool"
					if FF_GetControl("Filter Namensbestandteil","string_bool") = "1" Then
						FF_SetControl "Filter Namensbestandteil","diff_bool", "0"
						FF_EnableControl "Filter Namensbestandteil","bool1", True
					End If
				Case "diff_bool"
					if FF_GetControl("Filter Namensbestandteil","diff_bool") = "1" Then
						FF_SetControl "Filter Namensbestandteil","string_bool", "0"
						FF_EnableControl "Filter Namensbestandteil","bool1", False
					End If
				Case "CANCEL"
					FF_CloseDialog("Filter Namensbestandteil")
					FF_ErrorBreak "Abbruch durch Anwender"
				Case"nicht filtern"
					opt_nichtfiltern = "1"
					Exit Do
					'FF_CloseDialog("Filter Namensbestandteil")
					'FF_ErrorBreak ""
				Case "x"
					FF_SetControl "Filter Namensbestandteil","eingabe1", ""
				Case "OK"
					Exit Do
				Case "?"
					Call Hilfetext
			End Select
		loop

		wort = FF_GetControl("Filter Namensbestandteil","eingabe1")
		opt_zeichenkette = FF_GetControl("Filter Namensbestandteil", "string_bool")
		opt_differenz = FF_GetControl("Filter Namensbestandteil", "diff_bool")
		opt_stringnot = FF_GetControl("Filter Namensbestandteil", "bool1")
		opt_merken = FF_GetControl("Filter Namensbestandteil", "bool2")
		opt_casesense = FF_GetControl("Filter Namensbestandteil","casesen_bool")
		opt_endung = FF_GetControl("Filter Namensbestandteil","endung_bool")
		FF_CloseDialog("Filter Namensbestandteil")
	end if

	Call RegSchreiben

	if opt_nichtfiltern <> "1" Then  			' Filterung aktiv
		Call Filterung
	End If
End Sub
	
Sub Filterung
	files = split(FF_GetParam(),vbLf)

	If opt_zeichenkette = "1" Then					' Filter: Zeichenkette
		For i=0 to ubound(files)
			if opt_endung = 1 Then					' Dateiendung beim Filtern bercksichtigen
				Name = fso.GetFileName(files(i))	' Dateiname mit Endung ermitteln
			Else
				Name = fso.GetBaseName(files(i))	' Dateiname ohne Endung ermitteln
			End If
			if opt_casesense = "0" then				' Gro-/Kleinschreibung nicht beachten
				wort = LCase(wort)
				Name = LCase(Name)
			End If
			Select Case opt_stringnot
				Case 0							' String soll enthalten sein
					If  InStr(1, Name, wort, 0) > 0 Then 
						if len(str) > 0 Then str = str & vbLf end if
						str = str & files(i)
					end if
				Case 1							' String soll nicht enthalten sein
					If  InStr(1, Name, wort, 1) = 0 Then 
						if len(str) > 0 Then str = str & vbLf end if
						str = str & files(i)
					end if
			End Select
		next
		FF_SetParam(str)
	Else									' Filter: Differenzfilter
		if opt_casesense = "0" then			' Gro-/Kleinschreibung nicht beachten
			wort = LCase(wort)
		End If
		For i = 0 to ubound(files)
			if opt_endung = 1 Then									' Dateiendung beim Filtern bercksichtigen
				Name = fso.GetFileName(files(i))					' Dateiname mit Endung ermitteln
			Else
				Name = fso.GetBaseName(files(i))					' Dateiname ohne Endung ermitteln
			End If
			if opt_casesense = "0" then								' Gro-/Kleinschreibung nicht beachten
				Name = LCase(Name)
			End If
			If  InStr(1, Name, wort, 1) > 0 Then 					' Phrase ist enthalten, Bild wird aufgenommen
				if len(str) > 0 then str = str & vblf end if
				str = str & files(i)
			Else													' Phrase ist nicht enthalten, Differenzprfung
				Filemerker = False
				For u = 0 to ubound(files)
					if opt_endung = 1 Then							' Dateiendung beim Filtern bercksichtigen
						Name1 = fso.GetFileName(files(u))			' Dateiname mit Endung ermitteln
					Else
						Name1 = fso.GetBaseName(files(u))			' Dateiname ohne Endung ermitteln
					End If
					if opt_casesense = "0" then						' Gro-/Kleinschreibung nicht beachten
						Name1 = LCase(Name1)
					End If
					if Name <> Name1 Then							' Datei nicht mit sich selbst vergleichen
						REM msgbox "Name : " & name & vbNewLine & "Name1 : " & name1 & vbNewLine & "Wort : " & wort & vbNewLine & DoE(name1)
						if opt_endung = 0 Then					' Dateiendung beim Filtern nicht bercksichtigen
							if InStr(1, Name1, Name, 0) <> 0 and InStr(1, Name1, wort, 0) <> 0 Then	' Name wurde in einem weiteren File gefunden, dieses File enthlt auch die Phrase
								Filemerker = true					' true = Datei wird NICHT bernommen
							End If
						Else									' Dateiendung beim Filtern bercksichtigen, deshalb Filename und Endung gesondert prfen
							if InStr(1, DoE(Name1), DoE(Name), 0) <> 0 and InStr(1, Name1, wort, 0) <> 0 Then	' Name wurde in einem weiteren File gefunden, dieses File enthlt auch die Phrase
								Filemerker = true					' true = Datei wird NICHT bernommen
							End If
						End If
					End If
				Next
				if Filemerker = false Then							' Name wurde in keinem weiteren File gefunden, d.h. Bild wird aufgenommen
					if len(str) > 0 Then str = str & vbLf end if		
					str = str & files(i)
				End If
			end if
		Next
		FF_SetParam(str)
	End If
End Sub
	
Sub Initalisierung_Registry
	FF_WriteProfile RegSchluessel, "Initialisierung", "1"
	FF_WriteProfile RegSchluessel, "akt_Computeransicht", ""	'FF_GetImagePath
	FF_WriteProfile RegSchluessel, "eingabe",  ""
	FF_WriteProfile RegSchluessel, "opt_zeichenkette", "1"
	FF_WriteProfile RegSchluessel, "opt_differenz", 0
	FF_WriteProfile RegSchluessel, "opt_stringnot", 0
	FF_WriteProfile RegSchluessel, "opt_merken", "1"
	FF_WriteProfile RegSchluessel, "opt_casesense", "1"
	FF_WriteProfile RegSchluessel, "opt_endung", "1"
end sub

Sub RegSchreiben
	REM MsgBox "Reg schreiben: " & FF_GetImagePath
	FF_WriteProfile RegSchluessel,"akt_Computeransicht", FF_GetImagePath
	FF_WriteProfile RegSchluessel,"eingabe",  wort
	FF_WriteProfile RegSchluessel,"opt_zeichenkette",  opt_zeichenkette
	FF_WriteProfile RegSchluessel,"opt_differenz", opt_differenz
	FF_WriteProfile RegSchluessel,"opt_stringnot", opt_stringnot
	FF_WriteProfile RegSchluessel,"opt_merken", opt_merken
	FF_WriteProfile RegSchluessel,"opt_casesense", opt_casesense
	FF_WriteProfile RegSchluessel,"opt_nichtfiltern", opt_nichtfiltern
	FF_WriteProfile RegSchluessel,"opt_endung", opt_endung
End Sub

Sub Dialogaufbau
	'** Start Dialog Filter Namensbestandteil **
	FF_AddDialog "Filter Namensbestandteil",116,151
	FF_AddControl "Filter Namensbestandteil","Filtertyp","GROUP",2,31,111,70
	FF_AddControl "Filter Namensbestandteil","Teil des Dateinamens","GROUP",2,3,111,24
	FF_AddControl "Filter Namensbestandteil","Text soll nicht","STATIC",19,52,41,11
	FF_AddControl "Filter Namensbestandteil","bool1","BOOL",8,53,8,8
	FF_AddControl "Filter Namensbestandteil","OK","BUTTON",77,121,33,11
	FF_AddControl "Filter Namensbestandteil","nicht filtern","BUTTON",39,121,33,11
	FF_AddControl "Filter Namensbestandteil","eingabe1","SLEDIT",8,12,85,10
	FF_AddControl "Filter Namensbestandteil","(erneuter Aufruf mit F5)","STATIC",4,137,62,11
	FF_AddControl "Filter Namensbestandteil","bool2","BOOL",8,108,8,8
	FF_AddControl "Filter Namensbestandteil","Eingaben merken","STATIC",19,106,67,11
	FF_AddControl "Filter Namensbestandteil","?","BUTTON",97,136,13,11
	FF_AddControl "Filter Namensbestandteil","x","BUTTON",95,11,11,11
	FF_AddControl "Filter Namensbestandteil","string_bool","BOOL",8,42,8,8
	FF_SetControlStyle "Filter Namensbestandteil","string_bool",16384
	FF_AddControl "Filter Namensbestandteil","Zeichenkette","STATIC",20,40,33,11
	FF_AddControl "Filter Namensbestandteil","diff_bool","BOOL",66,42,8,8
	FF_SetControlStyle "Filter Namensbestandteil","diff_bool",16384
	FF_AddControl "Filter Namensbestandteil","Differenzfilter","STATIC",77,40,33,11
	FF_AddControl "Filter Namensbestandteil","enthalten sein","STATIC",19,61,42,11
	FF_AddControl "Filter Namensbestandteil","casesen_bool","BOOL",8,78,8,8
	FF_AddControl "Filter Namensbestandteil","Gro-/Kleinschreibung beachten","STATIC",19,76,85,11
	FF_AddControl "Filter Namensbestandteil",Version,"STATIC",75,136,21,11
	FF_SetControlStyle "Filter Namensbestandteil",Version,1
	FF_AddControl "Filter Namensbestandteil","endung_bool","BOOL",8,89,8,8
	FF_AddControl "Filter Namensbestandteil","Dateiendung bercksichtigen","STATIC",19,87,79,11
	'** End Dialog Filter Namensbestandteil **
End Sub

'** Start Kurzbeschreibung *********************************
'Filtern nach Namensbestandteilen
'=======================
'
'Filtert die Computeransicht nach Textteilen im Dateinamen.
'
'1. Filter nach Zeichenkette
' - Es werden nur die Bilder angezeigt, die den Filtertext im Dateinamen tragen.
' - Die Option "Text soll nicht enthalten sein" zeigt nur die Bilder,  
'    deren Dateinamen den Filtertext gerade nicht enthalten.
'
'2. Differenzfilter
' - Es werden alle Bilder angezeigt, jedoch von jedem Bild nur eine Version:
' - Existiert von einem Bild eine Version mit dem Filtertext im Namen 
'    (als Markierung, dass dieses die bereits bearbeitete Version des Bildes
'    ist) und eine Version ohne den Filtertext (d.h. das Originalbild) dann 
'    wird nur das Bild mit dem Filtertext im Namen angezeigt.
' - Existiert nur eine Version des Bildes, wird diese in jedem Fall angezeigt. 
' 
'3. allgemeine Filter-Optionen
' Es kann angeben werden, ob beim Filtern
' - die Gro- und Kleinschreibung beachtet wird,
' - die Dateiendung bercksichtigt wird (es kann also z.B. auch nach
'   "ab.jpg" gesucht bzw, gefiltert werden) 
'
'Nach leerer Eingabe oder Abbruch des Dialogs werden alle Bilder angezeigt
'(entspricht "Alle Formate").
'Der Filter bleibt auch nach Wechsel des Computer-Verzeichnisses wirksam.
'Erneuter Aufruf des bereits aktiven Filters mit der Funktionstaste F5.
'Die Option ""Eingaben merken" speichert die Parameter des Filters dauerhaft.
'
'[Andreas Kleingnther, 2010, 2011, 2012, 2014, 2016]
'** Ende Kurzbeschreibung **********************************

Dim objFs, Kurzbeschreibung, KBvorhanden, LaengeMax
Dim WshShell

const SkriptName = "FFCFmt_Namensbestandteil.vbs"			' Skriptname

Sub Hilfetext
	if not KBvorhanden then	call KurzbeschreibungLesen
	if KBvorhanden then
		set WshShell =  CreateObject("WScript.Shell")
		WshShell.Popup Kurzbeschreibung,,"Info"
	else
		msgbox "Keine Kurzbeschreibung gefunden!",,"Meldung"
	end if
End Sub

Sub KurzbeschreibungLesen
	on error resume next
	Const ForReading = 1
	Dim Skript, Anfang, Ende, Zeile
	
	Set objFS = CreateObject("Scripting.FileSystemObject")	 ' FileSystemObject
	Set Skript = objFS.OpenTextFile(FF_GetScriptPath & "\" & SkriptName, ForReading, False)
	
	if err.number = 53 then
		msgbox "Wahrscheinlich wurde der Originalskriptname " & """" & SkriptName & """" & " abgendert." & vbNewLine & _
		   	"Die Kurzbeschreibung kann daher nicht angezeigt werden.",,"Meldung"
		exit sub
	end if
	
	Do While Skript.AtEndOfStream <> True
		Zeile = Skript.ReadLine
		
		if instr(Zeile,"** Ende Kurzbeschreibung") > 0 then Ende = true
		if Ende then exit do
		
		if Anfang then Kurzbeschreibung = Kurzbeschreibung & mid(Zeile,2) & vbNewLine
		if len(Zeile)-1 > LaengeMax then LaengeMax = len(Zeile)-1
		
		if instr(Zeile,"** Start Kurzbeschreibung") > 0 then Anfang = true
	Loop
		
	if Anfang and Ende then KBvorhanden = true
	Skript.Close
End Sub

Function DoE (Dateiname)	' Dateiname ohne Endung
	DoE = Left(Dateiname, InStr(Dateiname,".") -1)
End Function